#include <common.h>
#include "gl.h"
#include "chunk.h"

#ifdef TEXTURE_SUPPORT
    #include "terrain.h"
#endif

/*int drawBox(GLFix x, GLFix y, GLFix z, GLFix w, GLFix h, GLFix l, TextureAtlasEntry fr, TextureAtlasEntry ba, TextureAtlasEntry to, TextureAtlasEntry bo, TextureAtlasEntry le, TextureAtlasEntry ri,
             bool draw_front, bool draw_back, bool draw_top, bool draw_bottom, bool draw_left, bool draw_right, VERTEX *buffer)
{
    w += x;
    h += y;
    l += z;

    VERTEX *old_buffer = buffer;

    if(draw_front)
    {
        *buffer++ = {x, y, z, fr.left, fr.bottom};
        *buffer++ = {x, h, z, fr.left, fr.top};
        *buffer++ = {w, h, z, fr.right, fr.top};
        *buffer++ = {w, y, z, fr.right, fr.bottom};
    }

    if(draw_back)
    {
        *buffer++ = {w, y, l, ba.left, ba.bottom};
        *buffer++ = {w, h, l, ba.left, ba.top};
        *buffer++ = {x, h, l, ba.right, ba.top};
        *buffer++ = {x, y, l, ba.right, ba.bottom};
    }

    if(draw_left)
    {
        *buffer++ = {x, y, l, le.left, le.bottom};
        *buffer++ = {x, h, l, le.left, le.top};
        *buffer++ = {x, h, z, le.right, le.top};
        *buffer++ = {x, y, z, le.right, le.bottom};
    }

    if(draw_right)
    {
        *buffer++ = {w, y, z, ri.left, ri.bottom};
        *buffer++ = {w, h, z, ri.left, ri.top};
        *buffer++ = {w, h, l, ri.right, ri.top};
        *buffer++ = {w, y, l, ri.right, ri.bottom};
    }

    if(draw_top)
    {
        *buffer++ = {x, h, z, to.left, to.bottom};
        *buffer++ = {x, h, l, to.left, to.top};
        *buffer++ = {w, h, l, to.right, to.top};
        *buffer++ = {w, h, z, to.right, to.bottom};
    }

    if(draw_bottom)
    {
        *buffer++ = {w, y, z, bo.left, bo.bottom};
        *buffer++ = {w, y, l, bo.left, bo.top};
        *buffer++ = {x, y, l, bo.right, bo.top};
        *buffer++ = {x, y, z, bo.right, bo.bottom};
    }

    return buffer - old_buffer;
}*/

int main()
{
    if(!lcd_isincolor())
    {
        show_msgbox("Error", "Your LCD hasn't got enough colors :-P");
        return EXIT_FAILURE;
    }

    nglInit();

    COLOR* screen_buffer = new COLOR[WIDTH*HEIGHT];
    nglSetBuffer(screen_buffer);

    #ifdef TEXTURE_SUPPORT
        init_blockData(&terrain);
        glBindTexture(&terrain);
    #else
        init_blockData(nullptr);
    #endif

    glLoadIdentity();

    Chunk chunk(0, 0, 0);

    GLFix x = 0, y = 400, z = -1400;
    GLFix xr = 0, yr = 0;
    GLFix incr = 5;
    GLFix angle = 0;

    while(!isKeyPressed(KEY_NSPIRE_ESC))
    {
        glColor3f(0.1, 0.1, 1); //Blue background
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

        glPushMatrix();

        nglRotateX(GLFix(359) - xr.normalise_angle());
        nglRotateY(GLFix(359) - yr.normalise_angle());
        glTranslatef(-x, -y, -z);

        if(isKeyPressed(KEY_NSPIRE_8))
            z += incr;
        if(isKeyPressed(KEY_NSPIRE_2))
            z -= incr;
        if(isKeyPressed(KEY_NSPIRE_6))
            x += incr;
        if(isKeyPressed(KEY_NSPIRE_4))
            x -= incr;
        if(isKeyPressed(KEY_NSPIRE_SHIFT))
            y -= incr;
        if(isKeyPressed(KEY_NSPIRE_SPACE))
            y += incr;

        if(isKeyPressed(KEY_NSPIRE_LEFT))
            yr -= incr;
        if(isKeyPressed(KEY_NSPIRE_RIGHT))
            yr += incr;
        if(isKeyPressed(KEY_NSPIRE_UP))
            xr -= incr;
        if(isKeyPressed(KEY_NSPIRE_DOWN))
            xr += incr;

        nglRotateY(angle);

        chunk.render();

        glPopMatrix();

        if(isKeyPressed(KEY_NSPIRE_X))
        {
            angle += incr;
            angle.normalise_angle();
        }

        nglDisplay();
    }

    free(screen_buffer);

    return EXIT_SUCCESS;
}
